#include "i2c.h"

void i2c_start(void){
    SCLT = 0; //Clock = Output
    SCL = 0; //Clock = Low
    SDOT = 1; //Data = input(pulled high) so Data = 1
    Delay10TCY(); //user may need to modify based on Fosc
    SCLT = 1; //Clock = input(pulled high) so Clock = 1
    Delay10TCY(); //user may need to modify based on Fosc
    if(!SCK) //Check if the clock is low. If so then delay
        Delay10TCYx(3); //user may need to modify based on Fosc
    SDOT = 0; //Data = Output
    SDO = 0; //Data = Low
    Delay10TCY(); // user may need to modify based on Fosc
}
void i2c_stop(void){
    SCLT = 0; //Clock = Output
    SCL = 0; //Clock = Low
    SDOT = 0; //Data = Output
    SDO = 0; //Data = Low
    Delay10TCY(); //user may need to modify based on Fosc
    SCLT = 1; //Clock = input(pulled high) so Clock = 1
    Delay10TCY(); //user may need to modify based on Fosc
    if(!SCK) //Check if the clock is low. If so then delay
        Delay10TCYx(3); //user may need to modify based on Fosc
    SDOT = 1; //Data = input(pulled high) so Data = 1
    Delay1TCY(); //user may need to modify based on Fosc
    Delay1TCY(); //user may need to modify based on Fosc
}
char i2c_ack(void){
    SCLT = 0; //Clock = Output
    SCL = 0; //Clock = Low
    SDOT = 1; //Data = input(pulled high) so Data = 1
    Delay10TCY(); //user may need to modify based on Fosc
    SCLT = 1; //Clock = input(pulled high) so Clock = 1
    Delay1TCY(); //1 cycle delay
    Delay1TCY(); //1 cycle delay
    if(!SCK) //Check if the clock is low. If so then delay
        Delay10TCYx(3); //user may need to modify based on Fosc
    if(SDI) //error if ack = 1, slave did not ack
        return ( 1 ); //return with acknowledge error
    else
        return ( 0 ); // return with no error
}

char i2c_ack2(void){
    SCLT = 0; //Clock = Output
    SCL = 0; //Clock = Low
    SDOT = 0; //Data = Output
    SDO = 0; //Data = Low
    Delay10TCY(); //user may need to modify based on Fosc
    SCLT = 1; //Clock = input(pulled high) so Clock = 1
    Delay10TCY(); //user may need to modify based on Fosc
    if(!SCK) //Check if the clock is low. If so then delay
        Delay10TCYx(3); //user may need to modify based on Fosc
    return 0;

}
void i2c_write(unsigned char byte){
char x,tmp;
    for(x=0;x<8;x++){ //Loop through 8 bits
        SCLT = 0; //Clock = Output
        SCL = 0; //Clock = Low
        if((byte & 0x80) != 0){ //BYTE AND 0x80 (0b10000000) (test if BIT7 != 0)
            SCLT = 0; //Clock = Output
            SCL = 0; //Clock = Low
            SDOT = 1; //Data = input(pulled high) so Data = 1
            Delay10TCY(); //user may need to modify based on Fosc
            SCLT = 1; //Clock = input(pulled high) so Clock = 1
            Delay10TCY(); //user may need to modify based on Fosc
            if(!SCK) //Check if the clock is low. If so then delay
                Delay10TCYx(3); //user may need to modify based on Fosc
        } else {
            SCLT = 0; //Clock = Output
            SCL = 0; //Clock = Low
            SDOT = 0; //Data = Output
            SDO = 0; //Data = Low
            Delay10TCY(); //user may need to modify based on Fosc
            SCLT = 1; //Clock = input(pulled high) so Clock = 1
            Delay10TCY(); //user may need to modify based on Fosc
            if(!SCK) //Check if the clock is low. If so then delay
                Delay10TCYx(3); //user may need to modify based on Fosc
        }
        byte <<= 1; //Shift Byte to LEFT by 1.
    }
}
unsigned char i2c_read(void){
unsigned char x,tmp = 0;
    SCLT = 0; //Clock = Output
    SCL = 0; //Clock = Low
    for(x=0;x<8;x++){ //Loop through 8 bits
        SCLT = 0; //Clock = Output
        SCL = 0; //Clock = Low
        SDOT = 1; //Data = input(pulled high) so Data = 1

        Delay10TCYx(3); //user may need to modify based on Fosc

        SCLT = 1; //Clock = input(pulled high) so Clock = 1
        Delay10TCYx(3); //user may need to modify based on Fosc

        tmp <<= 1; //Shift to LEFT by 1
        tmp &= 0xFE; //Make sure BIT 0 is a 0
        if(SDI) //If Data In is a 1 then OR it, if not then leave 0
            tmp |= 0x01;
    }
    return tmp; //Complete so return tmp (our received data)
}

void i2c_Ack(void){
//CLOCK LOW 
    SCLT = 0; //Clock = Output
    SCL = 0; //Clock = Low
//SET LOW
    SDOT = 0; //Data = Output
    SDO = 0; //Data = Low
//SMALL DELAY
    Delay10TCYx(3); //user may need to modify based on Fosc
//CLOCK HIGH
    SCLT = 1; //Clock = input(pulled high) so Clock = 1

}
void i2c_NAck(void){
//CLOCK LOW 
    SCLT = 0; //Clock = Output
    SCL = 0; //Clock = Low
//SET HIGH
    SDOT = 1; //Data = Input (HIGH)
//SMALL DELAY
    Delay10TCYx(3); //user may need to modify based on Fosc
//CLOCK HIGH
    SCLT = 1; //Clock = input(pulled high) so Clock = 1

}
void i2c_Start(void){
//DATA HIGH
    SDOT = 1; //Data = INPUT (*HIGH) 
//CLOCK LOW 
    SCLT = 1; //Clock = INPUT (*HIGH)
//DATA HIGH
    SDOT = 1; //Data = INPUT (*HIGH) 
//SMALL DELAY
    Delay10TCYx(3); //user may need to modify based on Fosc
//DATA LOW
    SDOT = 0; //Data = OUTPUT 
    SDO = 0; //Data = LOW
//SMALL DELAY
    Delay10TCYx(3); //user may need to modify based on Fosc
//CLOCK LOW
    SCLT = 0; //Clock = Output
    SCL = 0; //Clock = LOW
}

void i2c_Stop(void){
//DATA LOW
    SDOT = 0; //Data = OUTPUT 
    SDO = 0; //Data = LOW
//CLOCK HIGH 
    SCLT = 1; //Clock = INPUT (*HIGH)
//DATA LOW
    SDOT = 0; //Data = OUTPUT 
    SDO = 0; //Data = LOW
//SMALL DELAY
    Delay10TCYx(3); //user may need to modify based on Fosc
//DATA HIGH
    SDOT = 1; //Data = INPUT(*HIGH)
//SMALL DELAY
    Delay10TCYx(3); //user may need to modify based on Fosc
//CLOCK LOW
    SCLT = 0; //Clock = Output
    SCL = 0; //Clock = LOW
}

void ClockIt(void){
//CLOCK LOW
    SCLT = 0; //Clock = Output
    SCL = 0; //Clock = LOW
//SMALL DELAY
    Delay10TCYx(3); //user may need to modify based on Fosc
//CLOCK HIGH
    SCLT = 1; //Clock = input(pulled high) so Clock = 1

}