#ifndef __I2C_H
#define __I2C_H

#include <delays.h>
#include <p18cxxx.h>

#define SDO LATCbits.LATC4 //Serial Data
#define SCL LATCbits.LATC3 //Serial Clock

#define SDI PORTCbits.RC4 //Used when SDO is input
#define SCK PORTCbits.RC3 //Used when SCL is input

#define SDOT TRISCbits.TRISC4 //SDO Tris Control
#define SCLT TRISCbits.TRISC3 //SCL Tris Control

char i2c_ack2(void);
void i2c_start(void);
void i2c_stop(void);
char i2c_ack(void);
void i2c_write(unsigned char byte);
unsigned char i2c_read(void);

void i2c_NAck(void);
void i2c_Ack(void);
void i2c_Start(void);
void i2c_Stop(void);

void WriteX2402PI(unsigned char Address, unsigned char Data);
unsigned char ReadX2402PI(unsigned char Address);

#define WAdd 0b10010000 //Write address
#define RAdd 0b10010001 //Read address

#endif
